module bemsa
  real*8 :: coeff(1376)
  
contains
  function emsav(x,c) result(v)
    implicit none
    real*8,dimension(1:10)::x
    real*8,dimension(1:1376)::c
    real*8::v
    ! ::::::::::::::::::::
    real*8,dimension(1:1376)::p
    integer :: i    

    call bemsav(x,p)
    v=0.d0
    do i=1,1376
      v=v+p(i)*c(i)
    enddo
  
    return
  end function emsav
  
  subroutine bemsav(x,p)
    implicit none
    real*8,dimension(1:10),intent(in)::x
    real*8,dimension(1:1376),intent(out)::p
    ! ::::::::::::::::::::
    real*8,dimension(1:21)::m
    integer :: i    

    call evmono(x,m)
    call evpoly(m,p)
    
    return
  end subroutine bemsav
  
  subroutine evmono(x,m)
    implicit none
    real*8,dimension(1:10),intent(in)::x
    real*8,dimension(1:21),intent(out)::m
    !::::::::::::::::::::
    
!    m(0) = 1.0D0
    m(1) = x(10)
    m(2) = x(9)
    m(3) = x(8)
    m(4) = x(7)
    m(5) = x(4)
    m(6) = x(6)
    m(7) = x(3)
    m(8) = x(5)
    m(9) = x(2)
    m(10) = x(1)
    m(11) = m(4)*m(5)
    m(12) = m(5)*m(6)
    m(13) = m(4)*m(7)
    m(14) = m(6)*m(7)
    m(15) = m(5)*m(8)
    m(16) = m(4)*m(9)
    m(17) = m(7)*m(8)
    m(18) = m(6)*m(9)
    m(19) = m(8)*m(9)
    m(20) = m(5)*m(17)
    m(21) = m(4)*m(18)

    return
  end subroutine evmono

  subroutine evpoly(m,p)
    implicit none
    real*8,dimension(1:21),intent(in)::m
    real*8,dimension(1:1376),intent(out)::p
    real*8,dimension(1:1631)::d
    !::::::::::::::::::::
!    p(0) = m(0)

d( 3)= m( 3)
d( 5)= m( 6) + m( 7)
d( 6)= m( 8) + m( 9)
d( 7)= m(10)
d(  17)= d(   3) * d(   5)
d(19)= m(14)
d(  23)= d(   3) * d(   6)
d(25)= m(17) + m(18)
d(26)= m(19)
d(  28)= d(   5) * d(   6) - d(  25)
d(  31)= d(   3) * d(   7)
d(  33)= d(   7) * d(   5)
d(  34)= d(   7) * d(   6)
d(  37)= d(   3) * d(   3)
d(  39)= d(   5) * d(   5) - d(  19) - d(  19)
d(  40)= d(   6) * d(   6) - d(  26) - d(  26)
d(  41)= d(   7) * d(   7)
d(  57)= d(   3) * d(  19)
d(  71)= d(   3) * d(  25)
d(  75)= d(   3) * d(  26)
d(  84)= d(   3) * d(  28)
d(  86)= d(  19) * d(   6)
d(  87)= d(  26) * d(   5)
d(  98)= d(   3) * d(  33)
d( 100)= d(   7) * d(  19)
d( 104)= d(   3) * d(  34)
d( 106)= d(   7) * d(  25)
d( 107)= d(   7) * d(  26)
d( 109)= d(   7) * d(  28)
d( 125)= d(   3) * d(  17)
d( 130)= d(   3) * d(  39)
d( 132)= d(  19) * d(   5)
d( 136)= d(   3) * d(  23)
d( 138)= d(   5) * d(  25) - d(  86)
d( 140)= d(   5) * d(  28) - d(  86)
d( 143)= d(   3) * d(  40)
d( 145)= d(   6) * d(  25) - d(  87)
d( 146)= d(  26) * d(   6)
d( 148)= d(   5) * d(  40) - d( 145)
d( 151)= d(   3) * d(  31)
d( 153)= d(   7) * d(  39)
d( 154)= d(   7) * d(  40)
d( 157)= d(   3) * d(  41)
d( 159)= d(   7) * d(  33)
d( 160)= d(   7) * d(  34)
d( 163)= d(   3) * d(  37)
d( 165)= d(   5) * d(  39) - d( 132)
d( 166)= d(   6) * d(  40) - d( 146)
d( 167)= d(   7) * d(  41)
d( 224)= d(   3) * d(  86)
d( 228)= d(   3) * d(  87)
d( 230)= d(  19) * d(  26)
d( 252)= d(   3) * d( 100)
d( 266)= d(   3) * d( 106)
d( 270)= d(   3) * d( 107)
d( 279)= d(   3) * d( 109)
d( 281)= d(   7) * d(  86)
d( 282)= d(   7) * d(  87)
d( 316)= d(   3) * d(  57)
d( 334)= d(   3) * d( 132)
d( 355)= d(   3) * d(  71)
d( 359)= d(   3) * d( 138)
d( 363)= d(   3) * d(  75)
d( 377)= d(   3) * d(  84)
d( 379)= d(  19) * d(  25)
d( 383)= d(   3) * d( 140)
d( 385)= d(  19) * d(  28)
d( 386)= d(  26) * d(  39)
d( 396)= d(   3) * d( 145)
d( 400)= d(   3) * d( 146)
d( 402)= d(  26) * d(  25)
d( 411)= d(   3) * d( 148)
d( 413)= d(  19) * d(  40)
d( 414)= d(  26) * d(  28)
d( 431)= d(   3) * d(  98)
d( 436)= d(   3) * d( 153)
d( 438)= d(   7) * d( 132)
d( 442)= d(   3) * d( 104)
d( 444)= d(   7) * d( 138)
d( 446)= d(   7) * d( 140)
d( 449)= d(   3) * d( 154)
d( 451)= d(   7) * d( 145)
d( 452)= d(   7) * d( 146)
d( 454)= d(   7) * d( 148)
d( 464)= d(   3) * d( 159)
d( 466)= d(   7) * d( 100)
d( 470)= d(   3) * d( 160)
d( 472)= d(   7) * d( 106)
d( 473)= d(   7) * d( 107)
d( 475)= d(   7) * d( 109)
d( 498)= d(   3) * d( 125)
d( 503)= d(   3) * d( 130)
d( 505)= d(  19) * d(  19)
d( 509)= d(   3) * d( 165)
d( 511)= d(  19) * d(  39)
d( 515)= d(   3) * d( 136)
d( 517)= d(   5) * d( 138) - d( 379)
d( 519)= d(   5) * d( 140) - d( 385)
d( 522)= d(   3) * d( 143)
d( 524)= d(   5) * d( 145) - d( 413)
d( 525)= d(  26) * d(  26)
d( 527)= d(   5) * d( 148) - d( 413)
d( 530)= d(   3) * d( 166)
d( 532)= d(   6) * d( 145) - d( 402)
d( 533)= d(  26) * d(  40)
d( 535)= d(   5) * d( 166) - d( 532)
d( 538)= d(   3) * d( 151)
d( 540)= d(   7) * d( 165)
d( 541)= d(   7) * d( 166)
d( 544)= d(   3) * d( 157)
d( 546)= d(   7) * d( 153)
d( 547)= d(   7) * d( 154)
d( 550)= d(   3) * d( 167)
d( 552)= d(   7) * d( 159)
d( 553)= d(   7) * d( 160)
d( 556)= d(   3) * d( 163)
d( 558)= d(   5) * d( 165) - d( 511)
d( 559)= d(   6) * d( 166) - d( 533)
d( 560)= d(   7) * d( 167)
d( 614)= d(   3) * d( 230)
d( 686)= d(   3) * d( 281)
d( 690)= d(   3) * d( 282)
d( 692)= d(   7) * d( 230)
d( 862)= d(   3) * d( 224)
d( 866)= d(   3) * d( 379)
d( 870)= d(   3) * d( 228)
d( 891)= d(   3) * d( 385)
d( 895)= d(   3) * d( 386)
d( 897)= d(  19) * d(  87)
d( 922)= d(   3) * d( 402)
d( 947)= d(   3) * d( 413)
d( 951)= d(   3) * d( 414)
d( 953)= d(  19) * d( 146)
d( 992)= d(   3) * d( 252)
d(1010)= d(   3) * d( 438)
d(1031)= d(   3) * d( 266)
d(1035)= d(   3) * d( 444)
d(1039)= d(   3) * d( 270)
d(1053)= d(   3) * d( 279)
d(1055)= d(   7) * d( 379)
d(1059)= d(   3) * d( 446)
d(1061)= d(   7) * d( 385)
d(1062)= d(   7) * d( 386)
d(1072)= d(   3) * d( 451)
d(1076)= d(   3) * d( 452)
d(1078)= d(   7) * d( 402)
d(1087)= d(   3) * d( 454)
d(1089)= d(   7) * d( 413)
d(1090)= d(   7) * d( 414)
d(1107)= d(   3) * d( 466)
d(1121)= d(   3) * d( 472)
d(1125)= d(   3) * d( 473)
d(1134)= d(   3) * d( 475)
d(1136)= d(   7) * d( 281)
d(1137)= d(   7) * d( 282)
d(1195)= d(   3) * d( 316)
d(1223)= d(   3) * d( 334)
d(1227)= d(   3) * d( 505)
d(1246)= d(   3) * d( 511)
d(1273)= d(   3) * d( 355)
d(1277)= d(   3) * d( 359)
d(1281)= d(   3) * d( 517)
d(1285)= d(   3) * d( 363)
d(1304)= d(   3) * d( 377)
d(1306)= d(  19) * d( 138)
d(1310)= d(   3) * d( 383)
d(1312)= d(  19) * d(  86)
d(1316)= d(   3) * d( 519)
d(1318)= d(  19) * d( 140)
d(1319)= d(  26) * d( 165)
d(1335)= d(   3) * d( 396)
d(1339)= d(   3) * d( 524)
d(1343)= d(   3) * d( 400)
d(1345)= d(  26) * d( 138)
d(1348)= d(   3) * d( 525)
d(1363)= d(   3) * d( 411)
d(1365)= d(  19) * d( 145)
d(1366)= d(  26) * d(  87)
d(1370)= d(   3) * d( 527)
d(1372)= d(  19) * d( 148)
d(1373)= d(  26) * d( 140)
d(1383)= d(   3) * d( 532)
d(1387)= d(   3) * d( 533)
d(1389)= d(  26) * d( 145)
d(1398)= d(   3) * d( 535)
d(1400)= d(  19) * d( 166)
d(1401)= d(  26) * d( 148)
d(1425)= d(   3) * d( 431)
d(1430)= d(   3) * d( 436)
d(1432)= d(   7) * d( 505)
d(1436)= d(   3) * d( 540)
d(1438)= d(   7) * d( 511)
d(1442)= d(   3) * d( 442)
d(1444)= d(   7) * d( 517)
d(1446)= d(   7) * d( 519)
d(1449)= d(   3) * d( 449)
d(1451)= d(   7) * d( 524)
d(1452)= d(   7) * d( 525)
d(1454)= d(   7) * d( 527)
d(1457)= d(   3) * d( 541)
d(1459)= d(   7) * d( 532)
d(1460)= d(   7) * d( 533)
d(1462)= d(   7) * d( 535)
d(1478)= d(   3) * d( 464)
d(1483)= d(   3) * d( 546)
d(1485)= d(   7) * d( 438)
d(1489)= d(   3) * d( 470)
d(1491)= d(   7) * d( 444)
d(1493)= d(   7) * d( 446)
d(1496)= d(   3) * d( 547)
d(1498)= d(   7) * d( 451)
d(1499)= d(   7) * d( 452)
d(1501)= d(   7) * d( 454)
d(1511)= d(   3) * d( 552)
d(1513)= d(   7) * d( 466)
d(1517)= d(   3) * d( 553)
d(1519)= d(   7) * d( 472)
d(1520)= d(   7) * d( 473)
d(1522)= d(   7) * d( 475)
d(1551)= d(   3) * d( 498)
d(1556)= d(   3) * d( 503)
d(1561)= d(   3) * d( 509)
d(1563)= d(  19) * d( 132)
d(1567)= d(   3) * d( 558)
d(1569)= d(  19) * d( 165)
d(1573)= d(   3) * d( 515)
d(1575)= d(   5) * d( 517) - d(1306)
d(1577)= d(   5) * d( 519) - d(1318)
d(1580)= d(   3) * d( 522)
d(1582)= d(   5) * d( 524) - d(1365)
d(1584)= d(   5) * d( 527) - d(1372)
d(1587)= d(   3) * d( 530)
d(1589)= d(   5) * d( 532) - d(1400)
d(1590)= d(  26) * d( 146)
d(1592)= d(   5) * d( 535) - d(1400)
d(1595)= d(   3) * d( 559)
d(1597)= d(   6) * d( 532) - d(1389)
d(1598)= d(  26) * d( 166)
d(1600)= d(   5) * d( 559) - d(1597)
d(1603)= d(   3) * d( 538)
d(1605)= d(   7) * d( 558)
d(1606)= d(   7) * d( 559)
d(1609)= d(   3) * d( 544)
d(1611)= d(   7) * d( 540)
d(1612)= d(   7) * d( 541)
d(1615)= d(   3) * d( 550)
d(1617)= d(   7) * d( 546)
d(1618)= d(   7) * d( 547)
d(1621)= d(   3) * d( 560)
d(1623)= d(   7) * d( 552)
d(1624)= d(   7) * d( 553)
d(1627)= d(   3) * d( 556)
d(1629)= d(   5) * d( 558) - d(1569)
d(1630)= d(   6) * d( 559) - d(1598)
d(1631)= d(   7) * d( 560)

p( 1)= m( 1)
p( 2)= m( 2)
p( 3)= m( 4) + m( 5)
p(   4)=p(   1) *p(   2)
p(   5)=p(   1) *d(   3)
p(   6)=p(   2) *d(   3)
p(   7)=p(   1) *p(   3)
p(   8)=p(   2) *p(   3)
p(   9)=d(   3) *p(   3)
p(10)= m(11)
p(  11)=p(   1) *d(   5)
p(  12)=p(   2) *d(   5)
p(13)= m(12) + m(13)
p(  14)=p(   3) *d(   5) -p(  13)
p(  15)=p(   1) *d(   6)
p(  16)=p(   2) *d(   6)
p(17)= m(15) + m(16)
p(  18)=p(   3) *d(   6) -p(  17)
p(  19)=p(   1) *d(   7)
p(  20)=p(   2) *d(   7)
p(  21)=d(   7) *p(   3)
p(  22)=p(   1) *p(   1)
p(  23)=p(   2) *p(   2)
p(  24)=p(   3) *p(   3) -p(  10) -p(  10)
p(  25)=p(   1) *p(   6)
p(  26)=p(   1) *p(   8)
p(  27)=p(   1) *p(   9)
p(  28)=p(   2) *p(   9)
p(  29)=p(   1) *p(  10)
p(  30)=p(   2) *p(  10)
p(  31)=d(   3) *p(  10)
p(  32)=p(   1) *p(  12)
p(  33)=p(   1) *d(  17)
p(  34)=p(   2) *d(  17)
p(  35)=p(   1) *p(  13)
p(  36)=p(   2) *p(  13)
p(  37)=d(   3) *p(  13)
p(  38)=p(   1) *d(  19)
p(  39)=p(   2) *d(  19)
p(  40)=p(   1) *p(  14)
p(  41)=p(   2) *p(  14)
p(  42)=d(   3) *p(  14)
p(  43)=p(  10) *d(   5)
p(  44)=d(  19) *p(   3)
p(  45)=p(   1) *p(  16)
p(  46)=p(   1) *d(  23)
p(  47)=p(   2) *d(  23)
p(  48)=p(   1) *p(  17)
p(  49)=p(   2) *p(  17)
p(  50)=d(   3) *p(  17)
p(  51)=p(   1) *d(  25)
p(  52)=p(   2) *d(  25)
p(53)= m(20) + m(21)
p(  54)=p(   1) *d(  26)
p(  55)=p(   2) *d(  26)
p(  56)=p(   1) *p(  18)
p(  57)=p(   2) *p(  18)
p(  58)=d(   3) *p(  18)
p(  59)=p(  10) *d(   6)
p(  60)=p(   3) *d(  25) -p(  53)
p(  61)=d(  26) *p(   3)
p(  62)=p(   1) *d(  28)
p(  63)=p(   2) *d(  28)
p(  64)=d(   5) *p(  17) -p(  53)
p(  65)=p(   3) *d(  28) -p(  64)
p(  66)=p(   1) *p(  20)
p(  67)=p(   1) *d(  31)
p(  68)=p(   2) *d(  31)
p(  69)=p(   1) *p(  21)
p(  70)=p(   2) *p(  21)
p(  71)=d(   3) *p(  21)
p(  72)=d(   7) *p(  10)
p(  73)=p(   1) *d(  33)
p(  74)=p(   2) *d(  33)
p(  75)=d(   7) *p(  13)
p(  76)=d(   7) *p(  14)
p(  77)=p(   1) *d(  34)
p(  78)=p(   2) *d(  34)
p(  79)=d(   7) *p(  17)
p(  80)=d(   7) *p(  18)
p(  81)=p(   1) *p(   4)
p(  82)=p(   1) *p(  23)
p(  83)=p(   1) *p(   5)
p(  84)=p(   2) *p(   6)
p(  85)=p(   1) *d(  37)
p(  86)=p(   2) *d(  37)
p(  87)=p(   1) *p(   7)
p(  88)=p(   2) *p(   8)
p(  89)=d(   3) *p(   9)
p(  90)=p(   1) *p(  24)
p(  91)=p(   2) *p(  24)
p(  92)=d(   3) *p(  24)
p(  93)=p(  10) *p(   3)
p(  94)=p(   1) *p(  11)
p(  95)=p(   2) *p(  12)
p(  96)=p(   3) *p(  13) -p(  43)
p(  97)=p(   3) *p(  14) -p(  43)
p(  98)=p(   1) *d(  39)
p(  99)=p(   2) *d(  39)
p( 100)=d(   5) *p(  13) -p(  44)
p( 101)=p(   3) *d(  39) -p( 100)
p( 102)=p(   1) *p(  15)
p( 103)=p(   2) *p(  16)
p( 104)=p(   3) *p(  17) -p(  59)
p( 105)=p(   3) *p(  18) -p(  59)
p( 106)=p(   1) *d(  40)
p( 107)=p(   2) *d(  40)
p( 108)=d(   6) *p(  17) -p(  61)
p( 109)=p(   3) *d(  40) -p( 108)
p( 110)=p(   1) *p(  19)
p( 111)=p(   2) *p(  20)
p( 112)=d(   7) *p(  24)
p( 113)=p(   1) *d(  41)
p( 114)=p(   2) *d(  41)
p( 115)=d(   7) *p(  21)
p( 116)=p(   1) *p(  22)
p( 117)=p(   2) *p(  23)
p( 118)=p(   3) *p(  24) -p(  93)
p( 119)=p(   1) *p(  28)
p( 120)=p(   1) *p(  30)
p( 121)=p(   1) *p(  31)
p( 122)=p(   2) *p(  31)
p( 123)=p(   1) *p(  34)
p( 124)=p(   1) *p(  36)
p( 125)=p(   1) *p(  37)
p( 126)=p(   2) *p(  37)
p( 127)=p(   1) *p(  39)
p( 128)=p(   1) *d(  57)
p( 129)=p(   2) *d(  57)
p( 130)=p(   1) *p(  41)
p( 131)=p(   1) *p(  42)
p( 132)=p(   2) *p(  42)
p( 133)=p(   1) *p(  43)
p( 134)=p(   2) *p(  43)
p( 135)=d(   3) *p(  43)
p( 136)=p(   1) *p(  44)
p( 137)=p(   2) *p(  44)
p( 138)=d(   3) *p(  44)
p( 139)=p(  10) *d(  19)
p( 140)=p(   1) *p(  47)
p( 141)=p(   1) *p(  49)
p( 142)=p(   1) *p(  50)
p( 143)=p(   2) *p(  50)
p( 144)=p(   1) *p(  52)
p( 145)=p(   1) *d(  71)
p( 146)=p(   2) *d(  71)
p( 147)=p(   1) *p(  53)
p( 148)=p(   2) *p(  53)
p( 149)=d(   3) *p(  53)
p( 150)=p(   1) *p(  55)
p( 151)=p(   1) *d(  75)
p( 152)=p(   2) *d(  75)
p( 153)=p(   1) *p(  57)
p( 154)=p(   1) *p(  58)
p( 155)=p(   2) *p(  58)
p( 156)=p(   1) *p(  59)
p( 157)=p(   2) *p(  59)
p( 158)=d(   3) *p(  59)
p( 159)=p(   1) *p(  60)
p( 160)=p(   2) *p(  60)
p( 161)=d(   3) *p(  60)
p( 162)=p(  10) *d(  25)
p( 163)=p(   1) *p(  61)
p( 164)=p(   2) *p(  61)
p( 165)=d(   3) *p(  61)
p( 166)=p(  10) *d(  26)
p( 167)=p(   1) *p(  63)
p( 168)=p(   1) *d(  84)
p( 169)=p(   2) *d(  84)
p( 170)=p(   1) *p(  64)
p( 171)=p(   2) *p(  64)
p( 172)=d(   3) *p(  64)
p( 173)=p(   1) *d(  86)
p( 174)=p(   2) *d(  86)
p( 175)=d(  19) *p(  17)
p( 176)=p(   1) *d(  87)
p( 177)=p(   2) *d(  87)
p( 178)=d(  26) *p(  13)
p( 179)=p(   1) *p(  65)
p( 180)=p(   2) *p(  65)
p( 181)=d(   3) *p(  65)
p( 182)=p(  10) *d(  28)
p( 183)=d(  19) *p(  18)
p( 184)=d(  26) *p(  14)
p( 185)=p(   1) *p(  68)
p( 186)=p(   1) *p(  70)
p( 187)=p(   1) *p(  71)
p( 188)=p(   2) *p(  71)
p( 189)=p(   1) *p(  72)
p( 190)=p(   2) *p(  72)
p( 191)=d(   3) *p(  72)
p( 192)=p(   1) *p(  74)
p( 193)=p(   1) *d(  98)
p( 194)=p(   2) *d(  98)
p( 195)=p(   1) *p(  75)
p( 196)=p(   2) *p(  75)
p( 197)=d(   3) *p(  75)
p( 198)=p(   1) *d( 100)
p( 199)=p(   2) *d( 100)
p( 200)=p(   1) *p(  76)
p( 201)=p(   2) *p(  76)
p( 202)=d(   3) *p(  76)
p( 203)=d(   7) *p(  43)
p( 204)=d(   7) *p(  44)
p( 205)=p(   1) *p(  78)
p( 206)=p(   1) *d( 104)
p( 207)=p(   2) *d( 104)
p( 208)=p(   1) *p(  79)
p( 209)=p(   2) *p(  79)
p( 210)=d(   3) *p(  79)
p( 211)=p(   1) *d( 106)
p( 212)=p(   2) *d( 106)
p( 213)=d(   7) *p(  53)
p( 214)=p(   1) *d( 107)
p( 215)=p(   2) *d( 107)
p( 216)=p(   1) *p(  80)
p( 217)=p(   2) *p(  80)
p( 218)=d(   3) *p(  80)
p( 219)=d(   7) *p(  59)
p( 220)=d(   7) *p(  60)
p( 221)=d(   7) *p(  61)
p( 222)=p(   1) *d( 109)
p( 223)=p(   2) *d( 109)
p( 224)=d(   7) *p(  64)
p( 225)=d(   7) *p(  65)
p( 226)=p(   1) *p(  25)
p( 227)=p(   1) *p(  84)
p( 228)=p(   1) *p(  86)
p( 229)=p(   1) *p(  26)
p( 230)=p(   1) *p(  88)
p( 231)=p(   1) *p(  27)
p( 232)=p(   2) *p(  28)
p( 233)=p(   1) *p(  89)
p( 234)=p(   2) *p(  89)
p( 235)=p(   1) *p(  29)
p( 236)=p(   2) *p(  30)
p( 237)=d(   3) *p(  31)
p( 238)=p(   1) *p(  91)
p( 239)=p(   1) *p(  92)
p( 240)=p(   2) *p(  92)
p( 241)=p(   1) *p(  93)
p( 242)=p(   2) *p(  93)
p( 243)=d(   3) *p(  93)
p( 244)=p(   1) *p(  32)
p( 245)=p(   1) *p(  95)
p( 246)=p(   1) *p(  33)
p( 247)=p(   2) *p(  34)
p( 248)=p(   1) *d( 125)
p( 249)=p(   2) *d( 125)
p( 250)=p(   1) *p(  35)
p( 251)=p(   2) *p(  36)
p( 252)=d(   3) *p(  37)
p( 253)=p(   1) *p(  96)
p( 254)=p(   2) *p(  96)
p( 255)=d(   3) *p(  96)
p( 256)=p(   1) *p(  38)
p( 257)=p(   2) *p(  39)
p( 258)=p(   1) *p(  40)
p( 259)=p(   2) *p(  41)
p( 260)=d(   3) *p(  42)
p( 261)=p(  10) *p(  13)
p( 262)=p(   1) *p(  97)
p( 263)=p(   2) *p(  97)
p( 264)=d(   3) *p(  97)
p( 265)=p(  10) *p(  14)
p( 266)=d(  19) *p(  24)
p( 267)=p(   1) *p(  99)
p( 268)=p(   1) *d( 130)
p( 269)=p(   2) *d( 130)
p( 270)=p(   1) *p( 100)
p( 271)=p(   2) *p( 100)
p( 272)=d(   3) *p( 100)
p( 273)=p(   1) *d( 132)
p( 274)=p(   2) *d( 132)
p( 275)=d(  19) *p(  13)
p( 276)=p(   1) *p( 101)
p( 277)=p(   2) *p( 101)
p( 278)=d(   3) *p( 101)
p( 279)=p(  10) *d(  39)
p( 280)=d(  19) *p(  14)
p( 281)=p(   1) *p(  45)
p( 282)=p(   1) *p( 103)
p( 283)=p(   1) *p(  46)
p( 284)=p(   2) *p(  47)
p( 285)=p(   1) *d( 136)
p( 286)=p(   2) *d( 136)
p( 287)=p(   1) *p(  48)
p( 288)=p(   2) *p(  49)
p( 289)=d(   3) *p(  50)
p( 290)=p(   1) *p( 104)
p( 291)=p(   2) *p( 104)
p( 292)=d(   3) *p( 104)
p( 293)=p(   1) *p(  51)
p( 294)=p(   2) *p(  52)
p( 295)=p(   3) *p(  53) -p( 162)
p( 296)=p(   1) *d( 138)
p( 297)=p(   2) *d( 138)
p( 298)=d(   5) *p(  53) -p( 175)
p( 299)=p(   1) *p(  54)
p( 300)=p(   2) *p(  55)
p( 301)=p(   1) *p(  56)
p( 302)=p(   2) *p(  57)
p( 303)=d(   3) *p(  58)
p( 304)=p(  10) *p(  17)
p( 305)=p(   3) *d( 138) -p( 298)
p( 306)=p(   1) *p( 105)
p( 307)=p(   2) *p( 105)
p( 308)=d(   3) *p( 105)
p( 309)=p(  10) *p(  18)
p( 310)=p(   3) *p(  60) -p( 162)
p( 311)=d(  26) *p(  24)
p( 312)=p(   1) *p(  62)
p( 313)=p(   2) *p(  63)
p( 314)=p(   3) *p(  64) -p( 182)
p( 315)=p(   3) *p(  65) -p( 182)
p( 316)=p(   1) *d( 140)
p( 317)=p(   2) *d( 140)
p( 318)=d(   5) *p(  64) -p( 175)
p( 319)=p(   3) *d( 140) -p( 318)
p( 320)=p(   1) *p( 107)
p( 321)=p(   1) *d( 143)
p( 322)=p(   2) *d( 143)
p( 323)=p(   1) *p( 108)
p( 324)=p(   2) *p( 108)
p( 325)=d(   3) *p( 108)
p( 326)=p(   1) *d( 145)
p( 327)=p(   2) *d( 145)
p( 328)=d(   6) *p(  53) -p( 184)
p( 329)=p(   1) *d( 146)
p( 330)=p(   2) *d( 146)
p( 331)=d(  26) *p(  17)
p( 332)=p(   1) *p( 109)
p( 333)=p(   2) *p( 109)
p( 334)=d(   3) *p( 109)
p( 335)=p(  10) *d(  40)
p( 336)=p(   3) *d( 145) -p( 328)
p( 337)=d(  26) *p(  18)
p( 338)=p(   1) *d( 148)
p( 339)=p(   2) *d( 148)
p( 340)=d(   5) *p( 108) -p( 328)
p( 341)=p(   3) *d( 148) -p( 340)
p( 342)=p(   1) *p(  66)
p( 343)=p(   1) *p( 111)
p( 344)=p(   1) *p(  67)
p( 345)=p(   2) *p(  68)
p( 346)=p(   1) *d( 151)
p( 347)=p(   2) *d( 151)
p( 348)=p(   1) *p(  69)
p( 349)=p(   2) *p(  70)
p( 350)=d(   3) *p(  71)
p( 351)=p(   1) *p( 112)
p( 352)=p(   2) *p( 112)
p( 353)=d(   3) *p( 112)
p( 354)=d(   7) *p(  93)
p( 355)=p(   1) *p(  73)
p( 356)=p(   2) *p(  74)
p( 357)=d(   7) *p(  96)
p( 358)=d(   7) *p(  97)
p( 359)=p(   1) *d( 153)
p( 360)=p(   2) *d( 153)
p( 361)=d(   7) *p( 100)
p( 362)=d(   7) *p( 101)
p( 363)=p(   1) *p(  77)
p( 364)=p(   2) *p(  78)
p( 365)=d(   7) *p( 104)
p( 366)=d(   7) *p( 105)
p( 367)=p(   1) *d( 154)
p( 368)=p(   2) *d( 154)
p( 369)=d(   7) *p( 108)
p( 370)=d(   7) *p( 109)
p( 371)=p(   1) *p( 114)
p( 372)=p(   1) *d( 157)
p( 373)=p(   2) *d( 157)
p( 374)=p(   1) *p( 115)
p( 375)=p(   2) *p( 115)
p( 376)=d(   3) *p( 115)
p( 377)=d(   7) *p(  72)
p( 378)=p(   1) *d( 159)
p( 379)=p(   2) *d( 159)
p( 380)=d(   7) *p(  75)
p( 381)=d(   7) *p(  76)
p( 382)=p(   1) *d( 160)
p( 383)=p(   2) *d( 160)
p( 384)=d(   7) *p(  79)
p( 385)=d(   7) *p(  80)
p( 386)=p(   1) *p(  81)
p( 387)=p(   1) *p(  82)
p( 388)=p(   1) *p( 117)
p( 389)=p(   1) *p(  83)
p( 390)=p(   2) *p(  84)
p( 391)=p(   1) *p(  85)
p( 392)=p(   2) *p(  86)
p( 393)=p(   1) *d( 163)
p( 394)=p(   2) *d( 163)
p( 395)=p(   1) *p(  87)
p( 396)=p(   2) *p(  88)
p( 397)=d(   3) *p(  89)
p( 398)=p(   1) *p(  90)
p( 399)=p(   2) *p(  91)
p( 400)=d(   3) *p(  92)
p( 401)=p(  10) *p(  10)
p( 402)=p(   1) *p( 118)
p( 403)=p(   2) *p( 118)
p( 404)=d(   3) *p( 118)
p( 405)=p(  10) *p(  24)
p( 406)=p(   1) *p(  94)
p( 407)=p(   2) *p(  95)
p( 408)=p(   3) *p(  96) -p( 261)
p( 409)=p(   3) *p(  97) -p( 265)
p( 410)=p(   1) *p(  98)
p( 411)=p(   2) *p(  99)
p( 412)=p(   3) *p( 100) -p( 279)
p( 413)=p(   3) *p( 101) -p( 279)
p( 414)=p(   1) *d( 165)
p( 415)=p(   2) *d( 165)
p( 416)=d(   5) *p( 100) -p( 275)
p( 417)=p(   3) *d( 165) -p( 416)
p( 418)=p(   1) *p( 102)
p( 419)=p(   2) *p( 103)
p( 420)=p(   3) *p( 104) -p( 304)
p( 421)=p(   3) *p( 105) -p( 309)
p( 422)=p(   1) *p( 106)
p( 423)=p(   2) *p( 107)
p( 424)=p(   3) *p( 108) -p( 335)
p( 425)=p(   3) *p( 109) -p( 335)
p( 426)=p(   1) *d( 166)
p( 427)=p(   2) *d( 166)
p( 428)=d(   6) *p( 108) -p( 331)
p( 429)=p(   3) *d( 166) -p( 428)
p( 430)=p(   1) *p( 110)
p( 431)=p(   2) *p( 111)
p( 432)=d(   7) *p( 118)
p( 433)=p(   1) *p( 113)
p( 434)=p(   2) *p( 114)
p( 435)=d(   7) *p( 112)
p( 436)=p(   1) *d( 167)
p( 437)=p(   2) *d( 167)
p( 438)=d(   7) *p( 115)
p( 439)=p(   1) *p( 116)
p( 440)=p(   2) *p( 117)
p( 441)=p(   3) *p( 118) -p( 405)
p( 442)=p(   1) *p( 122)
p( 443)=p(   1) *p( 126)
p( 444)=p(   1) *p( 129)
p( 445)=p(   1) *p( 132)
p( 446)=p(   1) *p( 134)
p( 447)=p(   1) *p( 135)
p( 448)=p(   2) *p( 135)
p( 449)=p(   1) *p( 137)
p( 450)=p(   1) *p( 138)
p( 451)=p(   2) *p( 138)
p( 452)=p(   1) *p( 139)
p( 453)=p(   2) *p( 139)
p( 454)=d(   3) *p( 139)
p( 455)=p(   1) *p( 143)
p( 456)=p(   1) *p( 146)
p( 457)=p(   1) *p( 148)
p( 458)=p(   1) *p( 149)
p( 459)=p(   2) *p( 149)
p( 460)=p(   1) *p( 152)
p( 461)=p(   1) *p( 155)
p( 462)=p(   1) *p( 157)
p( 463)=p(   1) *p( 158)
p( 464)=p(   2) *p( 158)
p( 465)=p(   1) *p( 160)
p( 466)=p(   1) *p( 161)
p( 467)=p(   2) *p( 161)
p( 468)=p(   1) *p( 162)
p( 469)=p(   2) *p( 162)
p( 470)=d(   3) *p( 162)
p( 471)=p(   1) *p( 164)
p( 472)=p(   1) *p( 165)
p( 473)=p(   2) *p( 165)
p( 474)=p(   1) *p( 166)
p( 475)=p(   2) *p( 166)
p( 476)=d(   3) *p( 166)
p( 477)=p(   1) *p( 169)
p( 478)=p(   1) *p( 171)
p( 479)=p(   1) *p( 172)
p( 480)=p(   2) *p( 172)
p( 481)=p(   1) *p( 174)
p( 482)=p(   1) *d( 224)
p( 483)=p(   2) *d( 224)
p( 484)=p(   1) *p( 175)
p( 485)=p(   2) *p( 175)
p( 486)=d(   3) *p( 175)
p( 487)=p(   1) *p( 177)
p( 488)=p(   1) *d( 228)
p( 489)=p(   2) *d( 228)
p( 490)=p(   1) *p( 178)
p( 491)=p(   2) *p( 178)
p( 492)=d(   3) *p( 178)
p( 493)=p(   1) *d( 230)
p( 494)=p(   2) *d( 230)
p( 495)=p(   1) *p( 180)
p( 496)=p(   1) *p( 181)
p( 497)=p(   2) *p( 181)
p( 498)=p(   1) *p( 182)
p( 499)=p(   2) *p( 182)
p( 500)=d(   3) *p( 182)
p( 501)=p(   1) *p( 183)
p( 502)=p(   2) *p( 183)
p( 503)=d(   3) *p( 183)
p( 504)=p(  10) *d(  86)
p( 505)=p(   1) *p( 184)
p( 506)=p(   2) *p( 184)
p( 507)=d(   3) *p( 184)
p( 508)=p(  10) *d(  87)
p( 509)=d(  19) *p(  61)
p( 510)=p(   1) *p( 188)
p( 511)=p(   1) *p( 190)
p( 512)=p(   1) *p( 191)
p( 513)=p(   2) *p( 191)
p( 514)=p(   1) *p( 194)
p( 515)=p(   1) *p( 196)
p( 516)=p(   1) *p( 197)
p( 517)=p(   2) *p( 197)
p( 518)=p(   1) *p( 199)
p( 519)=p(   1) *d( 252)
p( 520)=p(   2) *d( 252)
p( 521)=p(   1) *p( 201)
p( 522)=p(   1) *p( 202)
p( 523)=p(   2) *p( 202)
p( 524)=p(   1) *p( 203)
p( 525)=p(   2) *p( 203)
p( 526)=d(   3) *p( 203)
p( 527)=p(   1) *p( 204)
p( 528)=p(   2) *p( 204)
p( 529)=d(   3) *p( 204)
p( 530)=d(   7) *p( 139)
p( 531)=p(   1) *p( 207)
p( 532)=p(   1) *p( 209)
p( 533)=p(   1) *p( 210)
p( 534)=p(   2) *p( 210)
p( 535)=p(   1) *p( 212)
p( 536)=p(   1) *d( 266)
p( 537)=p(   2) *d( 266)
p( 538)=p(   1) *p( 213)
p( 539)=p(   2) *p( 213)
p( 540)=d(   3) *p( 213)
p( 541)=p(   1) *p( 215)
p( 542)=p(   1) *d( 270)
p( 543)=p(   2) *d( 270)
p( 544)=p(   1) *p( 217)
p( 545)=p(   1) *p( 218)
p( 546)=p(   2) *p( 218)
p( 547)=p(   1) *p( 219)
p( 548)=p(   2) *p( 219)
p( 549)=d(   3) *p( 219)
p( 550)=p(   1) *p( 220)
p( 551)=p(   2) *p( 220)
p( 552)=d(   3) *p( 220)
p( 553)=d(   7) *p( 162)
p( 554)=p(   1) *p( 221)
p( 555)=p(   2) *p( 221)
p( 556)=d(   3) *p( 221)
p( 557)=d(   7) *p( 166)
p( 558)=p(   1) *p( 223)
p( 559)=p(   1) *d( 279)
p( 560)=p(   2) *d( 279)
p( 561)=p(   1) *p( 224)
p( 562)=p(   2) *p( 224)
p( 563)=d(   3) *p( 224)
p( 564)=p(   1) *d( 281)
p( 565)=p(   2) *d( 281)
p( 566)=d(   7) *p( 175)
p( 567)=p(   1) *d( 282)
p( 568)=p(   2) *d( 282)
p( 569)=d(   7) *p( 178)
p( 570)=p(   1) *p( 225)
p( 571)=p(   2) *p( 225)
p( 572)=d(   3) *p( 225)
p( 573)=d(   7) *p( 182)
p( 574)=d(   7) *p( 183)
p( 575)=d(   7) *p( 184)
p( 576)=p(   1) *p( 119)
p( 577)=p(   1) *p( 232)
p( 578)=p(   1) *p( 234)
p( 579)=p(   1) *p( 120)
p( 580)=p(   1) *p( 236)
p( 581)=p(   1) *p( 121)
p( 582)=p(   2) *p( 122)
p( 583)=p(   1) *p( 237)
p( 584)=p(   2) *p( 237)
p( 585)=p(   1) *p( 240)
p( 586)=p(   1) *p( 242)
p( 587)=p(   1) *p( 243)
p( 588)=p(   2) *p( 243)
p( 589)=p(   1) *p( 123)
p( 590)=p(   1) *p( 247)
p( 591)=p(   1) *p( 249)
p( 592)=p(   1) *p( 124)
p( 593)=p(   1) *p( 251)
p( 594)=p(   1) *p( 125)
p( 595)=p(   2) *p( 126)
p( 596)=p(   1) *p( 252)
p( 597)=p(   2) *p( 252)
p( 598)=p(   1) *p( 254)
p( 599)=p(   1) *p( 255)
p( 600)=p(   2) *p( 255)
p( 601)=p(   1) *p( 127)
p( 602)=p(   1) *p( 257)
p( 603)=p(   1) *p( 128)
p( 604)=p(   2) *p( 129)
p( 605)=p(   1) *d( 316)
p( 606)=p(   2) *d( 316)
p( 607)=p(   1) *p( 130)
p( 608)=p(   1) *p( 259)
p( 609)=p(   1) *p( 131)
p( 610)=p(   2) *p( 132)
p( 611)=p(   1) *p( 260)
p( 612)=p(   2) *p( 260)
p( 613)=p(   1) *p( 133)
p( 614)=p(   2) *p( 134)
p( 615)=d(   3) *p( 135)
p( 616)=p(   1) *p( 261)
p( 617)=p(   2) *p( 261)
p( 618)=d(   3) *p( 261)
p( 619)=p(   1) *p( 136)
p( 620)=p(   2) *p( 137)
p( 621)=d(   3) *p( 138)
p( 622)=p(   1) *p( 263)
p( 623)=p(   1) *p( 264)
p( 624)=p(   2) *p( 264)
p( 625)=p(   1) *p( 265)
p( 626)=p(   2) *p( 265)
p( 627)=d(   3) *p( 265)
p( 628)=p(   1) *p( 266)
p( 629)=p(   2) *p( 266)
p( 630)=d(   3) *p( 266)
p( 631)=p(  10) *p(  44)
p( 632)=p(   1) *p( 269)
p( 633)=p(   1) *p( 271)
p( 634)=p(   1) *p( 272)
p( 635)=p(   2) *p( 272)
p( 636)=p(   1) *p( 274)
p( 637)=p(   1) *d( 334)
p( 638)=p(   2) *d( 334)
p( 639)=p(   1) *p( 275)
p( 640)=p(   2) *p( 275)
p( 641)=d(   3) *p( 275)
p( 642)=p(   1) *p( 277)
p( 643)=p(   1) *p( 278)
p( 644)=p(   2) *p( 278)
p( 645)=p(   1) *p( 279)
p( 646)=p(   2) *p( 279)
p( 647)=d(   3) *p( 279)
p( 648)=p(   1) *p( 280)
p( 649)=p(   2) *p( 280)
p( 650)=d(   3) *p( 280)
p( 651)=p(  10) *d( 132)
p( 652)=p(   1) *p( 140)
p( 653)=p(   1) *p( 284)
p( 654)=p(   1) *p( 286)
p( 655)=p(   1) *p( 141)
p( 656)=p(   1) *p( 288)
p( 657)=p(   1) *p( 142)
p( 658)=p(   2) *p( 143)
p( 659)=p(   1) *p( 289)
p( 660)=p(   2) *p( 289)
p( 661)=p(   1) *p( 291)
p( 662)=p(   1) *p( 292)
p( 663)=p(   2) *p( 292)
p( 664)=p(   1) *p( 144)
p( 665)=p(   1) *p( 294)
p( 666)=p(   1) *p( 145)
p( 667)=p(   2) *p( 146)
p( 668)=p(   1) *d( 355)
p( 669)=p(   2) *d( 355)
p( 670)=p(   1) *p( 147)
p( 671)=p(   2) *p( 148)
p( 672)=d(   3) *p( 149)
p( 673)=p(   1) *p( 295)
p( 674)=p(   2) *p( 295)
p( 675)=d(   3) *p( 295)
p( 676)=p(   1) *p( 297)
p( 677)=p(   1) *d( 359)
p( 678)=p(   2) *d( 359)
p( 679)=p(   1) *p( 298)
p( 680)=p(   2) *p( 298)
p( 681)=d(   3) *p( 298)
p( 682)=p(   1) *p( 150)
p( 683)=p(   1) *p( 300)
p( 684)=p(   1) *p( 151)
p( 685)=p(   2) *p( 152)
p( 686)=p(   1) *d( 363)
p( 687)=p(   2) *d( 363)
p( 688)=p(   1) *p( 153)
p( 689)=p(   1) *p( 302)
p( 690)=p(   1) *p( 154)
p( 691)=p(   2) *p( 155)
p( 692)=p(   1) *p( 303)
p( 693)=p(   2) *p( 303)
p( 694)=p(   1) *p( 156)
p( 695)=p(   2) *p( 157)
p( 696)=d(   3) *p( 158)
p( 697)=p(   1) *p( 304)
p( 698)=p(   2) *p( 304)
p( 699)=d(   3) *p( 304)
p( 700)=p(   1) *p( 159)
p( 701)=p(   2) *p( 160)
p( 702)=d(   3) *p( 161)
p( 703)=p(  10) *p(  53)
p( 704)=p(   1) *p( 305)
p( 705)=p(   2) *p( 305)
p( 706)=d(   3) *p( 305)
p( 707)=p(  10) *d( 138)
p( 708)=p(   1) *p( 163)
p( 709)=p(   2) *p( 164)
p( 710)=d(   3) *p( 165)
p( 711)=p(   1) *p( 307)
p( 712)=p(   1) *p( 308)
p( 713)=p(   2) *p( 308)
p( 714)=p(   1) *p( 309)
p( 715)=p(   2) *p( 309)
p( 716)=d(   3) *p( 309)
p( 717)=p(   1) *p( 310)
p( 718)=p(   2) *p( 310)
p( 719)=d(   3) *p( 310)
p( 720)=p(  10) *p(  60)
p( 721)=p(   1) *p( 311)
p( 722)=p(   2) *p( 311)
p( 723)=d(   3) *p( 311)
p( 724)=p(  10) *p(  61)
p( 725)=p(   1) *p( 167)
p( 726)=p(   1) *p( 313)
p( 727)=p(   1) *p( 168)
p( 728)=p(   2) *p( 169)
p( 729)=p(   1) *d( 377)
p( 730)=p(   2) *d( 377)
p( 731)=p(   1) *p( 170)
p( 732)=p(   2) *p( 171)
p( 733)=d(   3) *p( 172)
p( 734)=p(   1) *p( 314)
p( 735)=p(   2) *p( 314)
p( 736)=d(   3) *p( 314)
p( 737)=p(   1) *p( 173)
p( 738)=p(   2) *p( 174)
p( 739)=d(  19) *p( 104)
p( 740)=p(   1) *d( 379)
p( 741)=p(   2) *d( 379)
p( 742)=d(  19) *p(  53)
p( 743)=p(   1) *p( 176)
p( 744)=p(   2) *p( 177)
p( 745)=d(  26) *p(  96)
p( 746)=p(   1) *p( 179)
p( 747)=p(   2) *p( 180)
p( 748)=d(   3) *p( 181)
p( 749)=p(  10) *p(  64)
p( 750)=d(  19) *p(  60)
p( 751)=p(   1) *p( 315)
p( 752)=p(   2) *p( 315)
p( 753)=d(   3) *p( 315)
p( 754)=p(  10) *p(  65)
p( 755)=d(  19) *p( 105)
p( 756)=d(  26) *p(  97)
p( 757)=p(   1) *p( 317)
p( 758)=p(   1) *d( 383)
p( 759)=p(   2) *d( 383)
p( 760)=p(   1) *p( 318)
p( 761)=p(   2) *p( 318)
p( 762)=d(   3) *p( 318)
p( 763)=p(   1) *d( 385)
p( 764)=p(   2) *d( 385)
p( 765)=d(  19) *p(  64)
p( 766)=p(   1) *d( 386)
p( 767)=p(   2) *d( 386)
p( 768)=d(  26) *p( 100)
p( 769)=p(   1) *p( 319)
p( 770)=p(   2) *p( 319)
p( 771)=d(   3) *p( 319)
p( 772)=p(  10) *d( 140)
p( 773)=d(  19) *p(  65)
p( 774)=d(  26) *p( 101)
p( 775)=p(   1) *p( 322)
p( 776)=p(   1) *p( 324)
p( 777)=p(   1) *p( 325)
p( 778)=p(   2) *p( 325)
p( 779)=p(   1) *p( 327)
p( 780)=p(   1) *d( 396)
p( 781)=p(   2) *d( 396)
p( 782)=p(   1) *p( 328)
p( 783)=p(   2) *p( 328)
p( 784)=d(   3) *p( 328)
p( 785)=p(   1) *p( 330)
p( 786)=p(   1) *d( 400)
p( 787)=p(   2) *d( 400)
p( 788)=p(   1) *p( 331)
p( 789)=p(   2) *p( 331)
p( 790)=d(   3) *p( 331)
p( 791)=p(   1) *d( 402)
p( 792)=p(   2) *d( 402)
p( 793)=d(  26) *p(  53)
p( 794)=p(   1) *p( 333)
p( 795)=p(   1) *p( 334)
p( 796)=p(   2) *p( 334)
p( 797)=p(   1) *p( 335)
p( 798)=p(   2) *p( 335)
p( 799)=d(   3) *p( 335)
p( 800)=p(   1) *p( 336)
p( 801)=p(   2) *p( 336)
p( 802)=d(   3) *p( 336)
p( 803)=p(  10) *d( 145)
p( 804)=p(   1) *p( 337)
p( 805)=p(   2) *p( 337)
p( 806)=d(   3) *p( 337)
p( 807)=p(  10) *d( 146)
p( 808)=d(  26) *p(  60)
p( 809)=p(   1) *p( 339)
p( 810)=p(   1) *d( 411)
p( 811)=p(   2) *d( 411)
p( 812)=p(   1) *p( 340)
p( 813)=p(   2) *p( 340)
p( 814)=d(   3) *p( 340)
p( 815)=p(   1) *d( 413)
p( 816)=p(   2) *d( 413)
p( 817)=d(  19) *p( 108)
p( 818)=p(   1) *d( 414)
p( 819)=p(   2) *d( 414)
p( 820)=d(  26) *p(  64)
p( 821)=p(   1) *p( 341)
p( 822)=p(   2) *p( 341)
p( 823)=d(   3) *p( 341)
p( 824)=p(  10) *d( 148)
p( 825)=d(  19) *p( 109)
p( 826)=d(  26) *p(  65)
p( 827)=p(   1) *p( 185)
p( 828)=p(   1) *p( 345)
p( 829)=p(   1) *p( 347)
p( 830)=p(   1) *p( 186)
p( 831)=p(   1) *p( 349)
p( 832)=p(   1) *p( 187)
p( 833)=p(   2) *p( 188)
p( 834)=p(   1) *p( 350)
p( 835)=p(   2) *p( 350)
p( 836)=p(   1) *p( 189)
p( 837)=p(   2) *p( 190)
p( 838)=d(   3) *p( 191)
p( 839)=p(   1) *p( 352)
p( 840)=p(   1) *p( 353)
p( 841)=p(   2) *p( 353)
p( 842)=p(   1) *p( 354)
p( 843)=p(   2) *p( 354)
p( 844)=d(   3) *p( 354)
p( 845)=p(   1) *p( 192)
p( 846)=p(   1) *p( 356)
p( 847)=p(   1) *p( 193)
p( 848)=p(   2) *p( 194)
p( 849)=p(   1) *d( 431)
p( 850)=p(   2) *d( 431)
p( 851)=p(   1) *p( 195)
p( 852)=p(   2) *p( 196)
p( 853)=d(   3) *p( 197)
p( 854)=p(   1) *p( 357)
p( 855)=p(   2) *p( 357)
p( 856)=d(   3) *p( 357)
p( 857)=p(   1) *p( 198)
p( 858)=p(   2) *p( 199)
p( 859)=p(   1) *p( 200)
p( 860)=p(   2) *p( 201)
p( 861)=d(   3) *p( 202)
p( 862)=d(   7) *p( 261)
p( 863)=p(   1) *p( 358)
p( 864)=p(   2) *p( 358)
p( 865)=d(   3) *p( 358)
p( 866)=d(   7) *p( 265)
p( 867)=d(   7) *p( 266)
p( 868)=p(   1) *p( 360)
p( 869)=p(   1) *d( 436)
p( 870)=p(   2) *d( 436)
p( 871)=p(   1) *p( 361)
p( 872)=p(   2) *p( 361)
p( 873)=d(   3) *p( 361)
p( 874)=p(   1) *d( 438)
p( 875)=p(   2) *d( 438)
p( 876)=d(   7) *p( 275)
p( 877)=p(   1) *p( 362)
p( 878)=p(   2) *p( 362)
p( 879)=d(   3) *p( 362)
p( 880)=d(   7) *p( 279)
p( 881)=d(   7) *p( 280)
p( 882)=p(   1) *p( 205)
p( 883)=p(   1) *p( 364)
p( 884)=p(   1) *p( 206)
p( 885)=p(   2) *p( 207)
p( 886)=p(   1) *d( 442)
p( 887)=p(   2) *d( 442)
p( 888)=p(   1) *p( 208)
p( 889)=p(   2) *p( 209)
p( 890)=d(   3) *p( 210)
p( 891)=p(   1) *p( 365)
p( 892)=p(   2) *p( 365)
p( 893)=d(   3) *p( 365)
p( 894)=p(   1) *p( 211)
p( 895)=p(   2) *p( 212)
p( 896)=d(   7) *p( 295)
p( 897)=p(   1) *d( 444)
p( 898)=p(   2) *d( 444)
p( 899)=d(   7) *p( 298)
p( 900)=p(   1) *p( 214)
p( 901)=p(   2) *p( 215)
p( 902)=p(   1) *p( 216)
p( 903)=p(   2) *p( 217)
p( 904)=d(   3) *p( 218)
p( 905)=d(   7) *p( 304)
p( 906)=d(   7) *p( 305)
p( 907)=p(   1) *p( 366)
p( 908)=p(   2) *p( 366)
p( 909)=d(   3) *p( 366)
p( 910)=d(   7) *p( 309)
p( 911)=d(   7) *p( 310)
p( 912)=d(   7) *p( 311)
p( 913)=p(   1) *p( 222)
p( 914)=p(   2) *p( 223)
p( 915)=d(   7) *p( 314)
p( 916)=d(   7) *p( 315)
p( 917)=p(   1) *d( 446)
p( 918)=p(   2) *d( 446)
p( 919)=d(   7) *p( 318)
p( 920)=d(   7) *p( 319)
p( 921)=p(   1) *p( 368)
p( 922)=p(   1) *d( 449)
p( 923)=p(   2) *d( 449)
p( 924)=p(   1) *p( 369)
p( 925)=p(   2) *p( 369)
p( 926)=d(   3) *p( 369)
p( 927)=p(   1) *d( 451)
p( 928)=p(   2) *d( 451)
p( 929)=d(   7) *p( 328)
p( 930)=p(   1) *d( 452)
p( 931)=p(   2) *d( 452)
p( 932)=d(   7) *p( 331)
p( 933)=p(   1) *p( 370)
p( 934)=p(   2) *p( 370)
p( 935)=d(   3) *p( 370)
p( 936)=d(   7) *p( 335)
p( 937)=d(   7) *p( 336)
p( 938)=d(   7) *p( 337)
p( 939)=p(   1) *d( 454)
p( 940)=p(   2) *d( 454)
p( 941)=d(   7) *p( 340)
p( 942)=d(   7) *p( 341)
p( 943)=p(   1) *p( 373)
p( 944)=p(   1) *p( 375)
p( 945)=p(   1) *p( 376)
p( 946)=p(   2) *p( 376)
p( 947)=p(   1) *p( 377)
p( 948)=p(   2) *p( 377)
p( 949)=d(   3) *p( 377)
p( 950)=p(   1) *p( 379)
p( 951)=p(   1) *d( 464)
p( 952)=p(   2) *d( 464)
p( 953)=p(   1) *p( 380)
p( 954)=p(   2) *p( 380)
p( 955)=d(   3) *p( 380)
p( 956)=p(   1) *d( 466)
p( 957)=p(   2) *d( 466)
p( 958)=p(   1) *p( 381)
p( 959)=p(   2) *p( 381)
p( 960)=d(   3) *p( 381)
p( 961)=d(   7) *p( 203)
p( 962)=d(   7) *p( 204)
p( 963)=p(   1) *p( 383)
p( 964)=p(   1) *d( 470)
p( 965)=p(   2) *d( 470)
p( 966)=p(   1) *p( 384)
p( 967)=p(   2) *p( 384)
p( 968)=d(   3) *p( 384)
p( 969)=p(   1) *d( 472)
p( 970)=p(   2) *d( 472)
p( 971)=d(   7) *p( 213)
p( 972)=p(   1) *d( 473)
p( 973)=p(   2) *d( 473)
p( 974)=p(   1) *p( 385)
p( 975)=p(   2) *p( 385)
p( 976)=d(   3) *p( 385)
p( 977)=d(   7) *p( 219)
p( 978)=d(   7) *p( 220)
p( 979)=d(   7) *p( 221)
p( 980)=p(   1) *d( 475)
p( 981)=p(   2) *d( 475)
p( 982)=d(   7) *p( 224)
p( 983)=d(   7) *p( 225)
p( 984)=p(   1) *p( 226)
p( 985)=p(   1) *p( 227)
p( 986)=p(   1) *p( 390)
p( 987)=p(   1) *p( 228)
p( 988)=p(   1) *p( 392)
p( 989)=p(   1) *p( 394)
p( 990)=p(   1) *p( 229)
p( 991)=p(   1) *p( 230)
p( 992)=p(   1) *p( 396)
p( 993)=p(   1) *p( 231)
p( 994)=p(   2) *p( 232)
p( 995)=p(   1) *p( 233)
p( 996)=p(   2) *p( 234)
p( 997)=p(   1) *p( 397)
p( 998)=p(   2) *p( 397)
p( 999)=p(   1) *p( 235)
p(1000)=p(   2) *p( 236)
p(1001)=d(   3) *p( 237)
p(1002)=p(   1) *p( 238)
p(1003)=p(   1) *p( 399)
p(1004)=p(   1) *p( 239)
p(1005)=p(   2) *p( 240)
p(1006)=p(   1) *p( 400)
p(1007)=p(   2) *p( 400)
p(1008)=p(   1) *p( 241)
p(1009)=p(   2) *p( 242)
p(1010)=d(   3) *p( 243)
p(1011)=p(   1) *p( 401)
p(1012)=p(   2) *p( 401)
p(1013)=d(   3) *p( 401)
p(1014)=p(   1) *p( 403)
p(1015)=p(   1) *p( 404)
p(1016)=p(   2) *p( 404)
p(1017)=p(   1) *p( 405)
p(1018)=p(   2) *p( 405)
p(1019)=d(   3) *p( 405)
p(1020)=p(   1) *p( 244)
p(1021)=p(   1) *p( 245)
p(1022)=p(   1) *p( 407)
p(1023)=p(   1) *p( 246)
p(1024)=p(   2) *p( 247)
p(1025)=p(   1) *p( 248)
p(1026)=p(   2) *p( 249)
p(1027)=p(   1) *d( 498)
p(1028)=p(   2) *d( 498)
p(1029)=p(   1) *p( 250)
p(1030)=p(   2) *p( 251)
p(1031)=d(   3) *p( 252)
p(1032)=p(   1) *p( 253)
p(1033)=p(   2) *p( 254)
p(1034)=d(   3) *p( 255)
p(1035)=p(   1) *p( 408)
p(1036)=p(   2) *p( 408)
p(1037)=d(   3) *p( 408)
p(1038)=p(   1) *p( 256)
p(1039)=p(   2) *p( 257)
p(1040)=p(   1) *p( 258)
p(1041)=p(   2) *p( 259)
p(1042)=d(   3) *p( 260)
p(1043)=p(  10) *p(  96)
p(1044)=p(   1) *p( 262)
p(1045)=p(   2) *p( 263)
p(1046)=d(   3) *p( 264)
p(1047)=p(  10) *p(  43)
p(1048)=p(   1) *p( 409)
p(1049)=p(   2) *p( 409)
p(1050)=d(   3) *p( 409)
p(1051)=p(  10) *p(  97)
p(1052)=d(  19) *p( 118)
p(1053)=p(   1) *p( 267)
p(1054)=p(   1) *p( 411)
p(1055)=p(   1) *p( 268)
p(1056)=p(   2) *p( 269)
p(1057)=p(   1) *d( 503)
p(1058)=p(   2) *d( 503)
p(1059)=p(   1) *p( 270)
p(1060)=p(   2) *p( 271)
p(1061)=d(   3) *p( 272)
p(1062)=p(   1) *p( 412)
p(1063)=p(   2) *p( 412)
p(1064)=d(   3) *p( 412)
p(1065)=p(   1) *p( 273)
p(1066)=p(   2) *p( 274)
p(1067)=d(  19) *p(  96)
p(1068)=p(   1) *d( 505)
p(1069)=p(   2) *d( 505)
p(1070)=p(   1) *p( 276)
p(1071)=p(   2) *p( 277)
p(1072)=d(   3) *p( 278)
p(1073)=p(  10) *p( 100)
p(1074)=d(  19) *p(  44)
p(1075)=p(   1) *p( 413)
p(1076)=p(   2) *p( 413)
p(1077)=d(   3) *p( 413)
p(1078)=p(  10) *p( 101)
p(1079)=d(  19) *p(  97)
p(1080)=p(   1) *p( 415)
p(1081)=p(   1) *d( 509)
p(1082)=p(   2) *d( 509)
p(1083)=p(   1) *p( 416)
p(1084)=p(   2) *p( 416)
p(1085)=d(   3) *p( 416)
p(1086)=p(   1) *d( 511)
p(1087)=p(   2) *d( 511)
p(1088)=d(  19) *p( 100)
p(1089)=p(   1) *p( 417)
p(1090)=p(   2) *p( 417)
p(1091)=d(   3) *p( 417)
p(1092)=p(  10) *d( 165)
p(1093)=d(  19) *p( 101)
p(1094)=p(   1) *p( 281)
p(1095)=p(   1) *p( 282)
p(1096)=p(   1) *p( 419)
p(1097)=p(   1) *p( 283)
p(1098)=p(   2) *p( 284)
p(1099)=p(   1) *p( 285)
p(1100)=p(   2) *p( 286)
p(1101)=p(   1) *d( 515)
p(1102)=p(   2) *d( 515)
p(1103)=p(   1) *p( 287)
p(1104)=p(   2) *p( 288)
p(1105)=d(   3) *p( 289)
p(1106)=p(   1) *p( 290)
p(1107)=p(   2) *p( 291)
p(1108)=d(   3) *p( 292)
p(1109)=p(   1) *p( 420)
p(1110)=p(   2) *p( 420)
p(1111)=d(   3) *p( 420)
p(1112)=p(   1) *p( 293)
p(1113)=p(   2) *p( 294)
p(1114)=p(   3) *p( 295) -p( 703)
p(1115)=p(   1) *p( 296)
p(1116)=p(   2) *p( 297)
p(1117)=p(   3) *p( 298) -p( 707)
p(1118)=p(   1) *d( 517)
p(1119)=p(   2) *d( 517)
p(1120)=d(   5) *p( 298) -p( 742)
p(1121)=p(   1) *p( 299)
p(1122)=p(   2) *p( 300)
p(1123)=p(   1) *p( 301)
p(1124)=p(   2) *p( 302)
p(1125)=d(   3) *p( 303)
p(1126)=p(  10) *p( 104)
p(1127)=p(   3) *d( 517) -p(1120)
p(1128)=p(   1) *p( 306)
p(1129)=p(   2) *p( 307)
p(1130)=d(   3) *p( 308)
p(1131)=p(  10) *p(  59)
p(1132)=p(   3) *p( 305) -p( 707)
p(1133)=p(   1) *p( 421)
p(1134)=p(   2) *p( 421)
p(1135)=d(   3) *p( 421)
p(1136)=p(  10) *p( 105)
p(1137)=p(   3) *p( 310) -p( 720)
p(1138)=d(  26) *p( 118)
p(1139)=p(   1) *p( 312)
p(1140)=p(   2) *p( 313)
p(1141)=p(   3) *p( 314) -p( 749)
p(1142)=p(   3) *p( 315) -p( 754)
p(1143)=p(   1) *p( 316)
p(1144)=p(   2) *p( 317)
p(1145)=p(   3) *p( 318) -p( 772)
p(1146)=p(   3) *p( 319) -p( 772)
p(1147)=p(   1) *d( 519)
p(1148)=p(   2) *d( 519)
p(1149)=d(   5) *p( 318) -p( 765)
p(1150)=p(   3) *d( 519) -p(1149)
p(1151)=p(   1) *p( 320)
p(1152)=p(   1) *p( 423)
p(1153)=p(   1) *p( 321)
p(1154)=p(   2) *p( 322)
p(1155)=p(   1) *d( 522)
p(1156)=p(   2) *d( 522)
p(1157)=p(   1) *p( 323)
p(1158)=p(   2) *p( 324)
p(1159)=d(   3) *p( 325)
p(1160)=p(   1) *p( 424)
p(1161)=p(   2) *p( 424)
p(1162)=d(   3) *p( 424)
p(1163)=p(   1) *p( 326)
p(1164)=p(   2) *p( 327)
p(1165)=p(   3) *p( 328) -p( 803)
p(1166)=p(   1) *d( 524)
p(1167)=p(   2) *d( 524)
p(1168)=d(   5) *p( 328) -p( 817)
p(1169)=p(   1) *p( 329)
p(1170)=p(   2) *p( 330)
p(1171)=d(  26) *p( 104)
p(1172)=p(   1) *d( 525)
p(1173)=p(   2) *d( 525)
p(1174)=p(   1) *p( 332)
p(1175)=p(   2) *p( 333)
p(1176)=d(   3) *p( 334)
p(1177)=p(  10) *p( 108)
p(1178)=p(   3) *d( 524) -p(1168)
p(1179)=d(  26) *p(  61)
p(1180)=p(   1) *p( 425)
p(1181)=p(   2) *p( 425)
p(1182)=d(   3) *p( 425)
p(1183)=p(  10) *p( 109)
p(1184)=p(   3) *p( 336) -p( 803)
p(1185)=d(  26) *p( 105)
p(1186)=p(   1) *p( 338)
p(1187)=p(   2) *p( 339)
p(1188)=p(   3) *p( 340) -p( 824)
p(1189)=p(   3) *p( 341) -p( 824)
p(1190)=p(   1) *d( 527)
p(1191)=p(   2) *d( 527)
p(1192)=d(   5) *p( 340) -p( 817)
p(1193)=p(   3) *d( 527) -p(1192)
p(1194)=p(   1) *p( 427)
p(1195)=p(   1) *d( 530)
p(1196)=p(   2) *d( 530)
p(1197)=p(   1) *p( 428)
p(1198)=p(   2) *p( 428)
p(1199)=d(   3) *p( 428)
p(1200)=p(   1) *d( 532)
p(1201)=p(   2) *d( 532)
p(1202)=d(   6) *p( 328) -p( 793)
p(1203)=p(   1) *d( 533)
p(1204)=p(   2) *d( 533)
p(1205)=d(  26) *p( 108)
p(1206)=p(   1) *p( 429)
p(1207)=p(   2) *p( 429)
p(1208)=d(   3) *p( 429)
p(1209)=p(  10) *d( 166)
p(1210)=p(   3) *d( 532) -p(1202)
p(1211)=d(  26) *p( 109)
p(1212)=p(   1) *d( 535)
p(1213)=p(   2) *d( 535)
p(1214)=d(   5) *p( 428) -p(1202)
p(1215)=p(   3) *d( 535) -p(1214)
p(1216)=p(   1) *p( 342)
p(1217)=p(   1) *p( 343)
p(1218)=p(   1) *p( 431)
p(1219)=p(   1) *p( 344)
p(1220)=p(   2) *p( 345)
p(1221)=p(   1) *p( 346)
p(1222)=p(   2) *p( 347)
p(1223)=p(   1) *d( 538)
p(1224)=p(   2) *d( 538)
p(1225)=p(   1) *p( 348)
p(1226)=p(   2) *p( 349)
p(1227)=d(   3) *p( 350)
p(1228)=p(   1) *p( 351)
p(1229)=p(   2) *p( 352)
p(1230)=d(   3) *p( 353)
p(1231)=d(   7) *p( 401)
p(1232)=p(   1) *p( 432)
p(1233)=p(   2) *p( 432)
p(1234)=d(   3) *p( 432)
p(1235)=d(   7) *p( 405)
p(1236)=p(   1) *p( 355)
p(1237)=p(   2) *p( 356)
p(1238)=d(   7) *p( 408)
p(1239)=d(   7) *p( 409)
p(1240)=p(   1) *p( 359)
p(1241)=p(   2) *p( 360)
p(1242)=d(   7) *p( 412)
p(1243)=d(   7) *p( 413)
p(1244)=p(   1) *d( 540)
p(1245)=p(   2) *d( 540)
p(1246)=d(   7) *p( 416)
p(1247)=d(   7) *p( 417)
p(1248)=p(   1) *p( 363)
p(1249)=p(   2) *p( 364)
p(1250)=d(   7) *p( 420)
p(1251)=d(   7) *p( 421)
p(1252)=p(   1) *p( 367)
p(1253)=p(   2) *p( 368)
p(1254)=d(   7) *p( 424)
p(1255)=d(   7) *p( 425)
p(1256)=p(   1) *d( 541)
p(1257)=p(   2) *d( 541)
p(1258)=d(   7) *p( 428)
p(1259)=d(   7) *p( 429)
p(1260)=p(   1) *p( 371)
p(1261)=p(   1) *p( 434)
p(1262)=p(   1) *p( 372)
p(1263)=p(   2) *p( 373)
p(1264)=p(   1) *d( 544)
p(1265)=p(   2) *d( 544)
p(1266)=p(   1) *p( 374)
p(1267)=p(   2) *p( 375)
p(1268)=d(   3) *p( 376)
p(1269)=p(   1) *p( 435)
p(1270)=p(   2) *p( 435)
p(1271)=d(   3) *p( 435)
p(1272)=d(   7) *p( 354)
p(1273)=p(   1) *p( 378)
p(1274)=p(   2) *p( 379)
p(1275)=d(   7) *p( 357)
p(1276)=d(   7) *p( 358)
p(1277)=p(   1) *d( 546)
p(1278)=p(   2) *d( 546)
p(1279)=d(   7) *p( 361)
p(1280)=d(   7) *p( 362)
p(1281)=p(   1) *p( 382)
p(1282)=p(   2) *p( 383)
p(1283)=d(   7) *p( 365)
p(1284)=d(   7) *p( 366)
p(1285)=p(   1) *d( 547)
p(1286)=p(   2) *d( 547)
p(1287)=d(   7) *p( 369)
p(1288)=d(   7) *p( 370)
p(1289)=p(   1) *p( 437)
p(1290)=p(   1) *d( 550)
p(1291)=p(   2) *d( 550)
p(1292)=p(   1) *p( 438)
p(1293)=p(   2) *p( 438)
p(1294)=d(   3) *p( 438)
p(1295)=d(   7) *p( 377)
p(1296)=p(   1) *d( 552)
p(1297)=p(   2) *d( 552)
p(1298)=d(   7) *p( 380)
p(1299)=d(   7) *p( 381)
p(1300)=p(   1) *d( 553)
p(1301)=p(   2) *d( 553)
p(1302)=d(   7) *p( 384)
p(1303)=d(   7) *p( 385)
p(1304)=p(   1) *p( 386)
p(1305)=p(   1) *p( 387)
p(1306)=p(   1) *p( 388)
p(1307)=p(   1) *p( 440)
p(1308)=p(   1) *p( 389)
p(1309)=p(   2) *p( 390)
p(1310)=p(   1) *p( 391)
p(1311)=p(   2) *p( 392)
p(1312)=p(   1) *p( 393)
p(1313)=p(   2) *p( 394)
p(1314)=p(   1) *d( 556)
p(1315)=p(   2) *d( 556)
p(1316)=p(   1) *p( 395)
p(1317)=p(   2) *p( 396)
p(1318)=d(   3) *p( 397)
p(1319)=p(   1) *p( 398)
p(1320)=p(   2) *p( 399)
p(1321)=d(   3) *p( 400)
p(1322)=p(   1) *p( 402)
p(1323)=p(   2) *p( 403)
p(1324)=d(   3) *p( 404)
p(1325)=p(  10) *p(  93)
p(1326)=p(   1) *p( 441)
p(1327)=p(   2) *p( 441)
p(1328)=d(   3) *p( 441)
p(1329)=p(  10) *p( 118)
p(1330)=p(   1) *p( 406)
p(1331)=p(   2) *p( 407)
p(1332)=p(   3) *p( 408) -p(1043)
p(1333)=p(   3) *p( 409) -p(1051)
p(1334)=p(   1) *p( 410)
p(1335)=p(   2) *p( 411)
p(1336)=p(   3) *p( 412) -p(1073)
p(1337)=p(   3) *p( 413) -p(1078)
p(1338)=p(   1) *p( 414)
p(1339)=p(   2) *p( 415)
p(1340)=p(   3) *p( 416) -p(1092)
p(1341)=p(   3) *p( 417) -p(1092)
p(1342)=p(   1) *d( 558)
p(1343)=p(   2) *d( 558)
p(1344)=d(   5) *p( 416) -p(1088)
p(1345)=p(   3) *d( 558) -p(1344)
p(1346)=p(   1) *p( 418)
p(1347)=p(   2) *p( 419)
p(1348)=p(   3) *p( 420) -p(1126)
p(1349)=p(   3) *p( 421) -p(1136)
p(1350)=p(   1) *p( 422)
p(1351)=p(   2) *p( 423)
p(1352)=p(   3) *p( 424) -p(1177)
p(1353)=p(   3) *p( 425) -p(1183)
p(1354)=p(   1) *p( 426)
p(1355)=p(   2) *p( 427)
p(1356)=p(   3) *p( 428) -p(1209)
p(1357)=p(   3) *p( 429) -p(1209)
p(1358)=p(   1) *d( 559)
p(1359)=p(   2) *d( 559)
p(1360)=d(   6) *p( 428) -p(1205)
p(1361)=p(   3) *d( 559) -p(1360)
p(1362)=p(   1) *p( 430)
p(1363)=p(   2) *p( 431)
p(1364)=d(   7) *p( 441)
p(1365)=p(   1) *p( 433)
p(1366)=p(   2) *p( 434)
p(1367)=d(   7) *p( 432)
p(1368)=p(   1) *p( 436)
p(1369)=p(   2) *p( 437)
p(1370)=d(   7) *p( 435)
p(1371)=p(   1) *d( 560)
p(1372)=p(   2) *d( 560)
p(1373)=d(   7) *p( 438)
p(1374)=p(   1) *p( 439)
p(1375)=p(   2) *p( 440)
p(1376)=p(   3) *p( 441) -p(1329)

  return
  end subroutine evpoly

end module bemsa

      subroutine pes(x,igrad,path,p,gradient_out,d)

      use bemsa
      implicit none
      ! number of electronic state
      integer, parameter :: nstates=1
      integer, parameter :: natoms=5
      integer, intent(in) :: igrad
      character(len=1024), intent(in) :: path
      double precision, intent(in) :: x(natoms,3)
      double precision, intent(out) :: p(nstates)
      double precision, intent(out) :: gradient_out(nstates,natoms,3)
      double precision, intent(out) :: d(nstates,nstates,natoms,3)

      real*8 :: v
      integer :: iatom, idir, j, istate
      logical, save :: first_time_data=.true.
      !initialize 
      gradient_out=0.d0
      d=0.d0

      if (igrad==0) then
        if(first_time_data) then
          call prepot(path)
          first_time_data=.false.
        endif
        call pot(x, v)
        v=v*27.211386
        do istate=1,nstates
          p(istate)=v
        enddo
      else
        write (*,*) 'Only energy is available'
      endif


      endsubroutine


subroutine prepot (path)
use bemsa
implicit none
character(len=1024), intent(in) :: path
character(len=1024) :: file_path1
integer :: i
integer, parameter:: dp=kind(0.d0)                   ! double precision

file_path1=trim(path)//"/HOCO_Ar/coeff_HOCO-Ar_under1.5_12432_C.dat"
open (10,FILE=file_path1)
do i = 1, 1376
  read (10,*) coeff (i)
enddo
close (10)
endsubroutine prepot

    subroutine pot(xyz,v)
    use bemsa
    integer, parameter:: dp=kind(0.d0)
    double precision, intent(in) :: xyz(5,3)
    double precision, intent(inout) :: v
    real(dp) :: x(10)
    real(dp) :: a1,a2
    
    a1=2.0
    a2=2.5

    x(1)=sqrt((xyz(1,1)-xyz(2,1))**2+(xyz(1,2)-xyz(2,2))**2+(xyz(1,3)-xyz(2,3))**2)
    x(2)=sqrt((xyz(1,1)-xyz(3,1))**2+(xyz(1,2)-xyz(3,2))**2+(xyz(1,3)-xyz(3,3))**2)
    x(3)=sqrt((xyz(1,1)-xyz(4,1))**2+(xyz(1,2)-xyz(4,2))**2+(xyz(1,3)-xyz(4,3))**2)
    x(4)=sqrt((xyz(1,1)-xyz(5,1))**2+(xyz(1,2)-xyz(5,2))**2+(xyz(1,3)-xyz(5,3))**2)
    x(5)=sqrt((xyz(2,1)-xyz(3,1))**2+(xyz(2,2)-xyz(3,2))**2+(xyz(2,3)-xyz(3,3))**2)
    x(6)=sqrt((xyz(2,1)-xyz(4,1))**2+(xyz(2,2)-xyz(4,2))**2+(xyz(2,3)-xyz(4,3))**2)
    x(7)=sqrt((xyz(2,1)-xyz(5,1))**2+(xyz(2,2)-xyz(5,2))**2+(xyz(2,3)-xyz(5,3))**2)
    x(8)=sqrt((xyz(3,1)-xyz(4,1))**2+(xyz(3,2)-xyz(4,2))**2+(xyz(3,3)-xyz(4,3))**2)
    x(9)=sqrt((xyz(3,1)-xyz(5,1))**2+(xyz(3,2)-xyz(5,2))**2+(xyz(3,3)-xyz(5,3))**2)
    x(10)=sqrt((xyz(4,1)-xyz(5,1))**2+(xyz(4,2)-xyz(5,2))**2+(xyz(4,3)-xyz(5,3))**2)

      x(1)=x(1)/0.5291772083_dp
      x(1)=exp(-x(1)/a1)
      x(2)=x(2)/0.5291772083_dp
      x(2)=exp(-x(2)/a1)
      x(3)=x(3)/0.5291772083_dp
      x(3)=exp(-x(3)/a1)
      x(4)=x(4)/0.5291772083_dp
      x(4)=exp(-x(4)/a2)
      x(5)=x(5)/0.5291772083_dp
      x(5)=exp(-x(5)/a1)
      x(6)=x(6)/0.5291772083_dp
      x(6)=exp(-x(6)/a1)
      x(7)=x(7)/0.5291772083_dp
      x(7)=exp(-x(7)/a2)
      x(8)=x(8)/0.5291772083_dp
      x(8)=exp(-x(8)/a1)
      x(9)=x(9)/0.5291772083_dp
      x(9)=exp(-x(9)/a2)
      x(10)=x(10)/0.5291772083_dp
      x(10)=exp(-x(10)/a2)

    v=emsav(x,coeff)


end  subroutine
